WITH Ada.Numerics.Discrete_Random;
WITH Ada.Text_IO;Use Ada.Text_IO;

PACKAGE Body Aleatoire IS
   
   FUNCTION Appartient(Tab : T_Integer ; I : Integer ; Aleatoire : Integer) RETURN Boolean IS
   BEGIN
      FOR J IN 1 .. I LOOP
         IF(Tab(J)=Aleatoire)THEN
            return true;
         END IF;
      END LOOP;
      RETURN False;
   END Appartient;
   
   --DEBUT Fonction qui renvoie un entier alatoire compris entre 0 et la valeur N passe en paramtre
   FUNCTION EchantillonAleatoire (
         Debut     : Integer;
         Fin       : Integer;
         NbElement : Integer)
         RETURN T_Integer IS
      
      Tab : T_Integer(1 .. NbElement);
      
      Aleatoire,I : Integer;

      SUBTYPE Nombres IS INTEGER RANGE Debut .. Fin;
      
      PACKAGE NombreAleatoire IS NEW Ada.Numerics.Discrete_Random (
         Nombres);
      
      USE NombreAleatoire;
      
      G : Generator;
   BEGIN
      I := 1;
      IF(NbElement>(Fin-Debut+1))THEN
         FOR J IN 1 .. NbElement LOOP
            Put("ERROR : Nombre d'lment suprieur  l'intervalle choisi");
            Tab(I) := -1;
         END LOOP;
      ELSE
         WHILE (I <= NbElement) LOOP
            Reset (G);
            Aleatoire := Integer(Random (G));
            If(NOT Appartient(Tab,I-1,Aleatoire))THEN
               Tab(I) := Aleatoire;
               I := I + 1;
            END IF;
             
         END LOOP;
      END IF;
      return Tab;
   END EchantillonAleatoire;
   --FIN

END Aleatoire;
